/***************************************************************************
 *     䠩 ᮤন ணࠬ  ࠡ    ᪮  *
 *  ०.  ⠭  ᯮ짮  䠩 GRAPHICS.H   䠩  *
 *  GRAPHICS.LIB, WND_ASM.HPP.                                             *
 *     ᯮ짮   ࠡ  ࠬ   ࠬ  *
 *    EGA.                                                           *
 *    ணࠬ  뢠    .                 *
 *    ணࠬ ᯮ ⠭ BIOS IBM,  ⮬,   -  *
 *  짮  IBM ᮢ⨬ 設, 室 㡥,  -  *
 *   BIOS ᮢ.        ////////////////140-141; 244-245           *
 ***************************************************************************/
#include  <wnd_asm.h>  /*   ⨯ 㭪権   */
#include <stdio.h>      /*    ࠡ  / */
#include <stdarg.h>     /*    ࠡ  va_ 㭪ﬨ */
#include <graphics.h>   /*    ࠡ  䨪 */
#include <string.h>     /*    ࠡ  ப */
#pragma inline          /*饭   ᯮ짮 ᥬ.*/

/**************************************************************************
 *  ணࠬ   ⪠ ࠭  ᯮ짮  *
 *  XOR.                                                                  *
 *  ᠭ ६:                                                  *
 *  bl - 㪠⥫   BLOCK, ᮤঠ न  塞 *
 *                                                                   *
 *  color - 梥                                            *
 **************************************************************************/

void  Chan_Block_Xor( BLOCK *bl, COLOR color, MODE oper ) {
   COLOR  col_pix = getpixel( bl->X1, bl->Y1 ); //⠥ 梥 ⥪饣
                                                //ᥫ

   color ^= col_pix;              //砥 室 梥 ᪨
   Chand( bl->X1, bl->Y1, bl->X2, bl->Y2, color, oper );  //᪠
   return;
}

/**************************************************************************
 *  ணࠬ   ⪠ ࠭,  ᯮ짮 ࠭ *
 *  梥. ந室  ⪠ ⭮ 8. ⢮ ப  - *
 *     (⨬).       ᯮ짮- *
 *   ᪨ 権 .                                   *
 *  !!!  㭪   ᯮ짮 ⮫o    ࠬ *
 *    GA.                                                          *
 *  ᠭ ६:                                                  *
 *  x -   砫                                  *
 *  y - ப  砫                                   *
 *  step_x - ⢮                                *
 *  step_y - ⢮  y                              *
 *  color - 梥                                                 *
 **************************************************************************/
void Chan_Block( int x, int y, int step_x, int step_y, COLOR color,
		 MODE oper ) {

    asm   PUSH ES         //࠭ . ᥣ
    asm      MOV  AX,x       //⠭   砫 ᥣ
    asm      MOV  CL,03H // !!!
    asm      SHR  AX,CL     //⭮ 8
    asm      MOV  BX,AX
    asm      MOV  AX,y       // ப 㬭  80  祭
    asm      MOV  CL,04H //!!!
    asm      SHL  AX,CL     //ᬥ饭  
    asm      ADD  BX,AX
    asm      MOV  CL,02H //!!!
    asm      SHL  AX,CL
    asm      ADD  BX,AX
    asm      MOV  AX,Start_Video_Buf  //뢠  砫 
    asm      MOV  ES,AX
    asm      MOV  DX,Video_Port //뤠 㪠   ० 
    asm      MOV  AL,05H       // ࠢ 0
    asm      OUT  DX,AL
    asm      INC  DX

    asm      XOR  AL,AL               //
    asm      OUT  DX,AL
    asm      DEC  DX           //蠥    
    asm      MOV  AL,08H       //⮢ ᪮
    asm      OUT  DX,AL
    asm      INC  DX
    asm      MOV  AL,11111111B // ࠧ襭
    asm      OUT  DX,AL
    asm      DEC  DX           //뢠   ᯮᮡ 
    asm      MOV  AL,03H       //ࠦ
    asm      OUT  DX,AL        //뢠  ॣ ᬥ饭
    asm      INC  DX
    asm      MOV  AL,oper      //뢠  
    asm      OUT  DX,AL        //塞 ॣ 饭
    asm      MOV  DX,Video_Color     //⠭ 梥  ࠭
    asm      MOV  AL,02H
    asm      OUT  DX,AL
    asm      INC  DX

    asm      MOV  AL,color           // 梥
    asm      OUT  DX,AL
    asm      MOV  CX,step_y   //뢠 ⢮ ப 
    asm      MOV  AH,0FFH    //⠭  梥⮢
    asm      MOV  AL,oper    // 
    asm      CMP  AL,0FH     //᫨ AND,   ࠢ 0
    asm      JNZ  NEXT_LINE
    asm      XOR  AH,AH      //  AND
NEXT_LINE: asm   XOR SI,SI //樠㥬 㪠⥫ ᨬ
REPEAT:
	   asm      MOV  AL,ES:[BX+SI] //⠥ ॣ 
	   asm      MOV  ES:[BX+SI],AH //塞 8 ᥫ

	   asm      INC  SI
	   asm      CMP  SI,step_x     //  ப ࠡ⠭ ?
	   asm      JB   REPEAT

	   asm      ADD  BX,Line_Next_Col
	   asm      LOOP NEXT_LINE     //  ப ࠡ⠭ ?
/*    asm      MOV  AL,03H       //
    asm      OUT  DX,AL        //뢠  ॣ ᬥ饭
    asm      INC  DX
    asm      MOV  AL,COPI      //뢠   ஢
    asm      OUT  DX,AL        //
*/
 asm      POP  ES            //⠭ ⥫ ᥣ
 bar(0,0,1,1);
 return;
}

/**************************************************************************
 *  ணࠬ  ⠭ ᪨ ᨬ  ᪮ ०.     *
 *    뢠 01Fh,   ࠭  -  *
 *   Old_Graph_Sim,    ⠭   㭪樨      *
 *  Back_Graph_Sim.                                                       *
 *  !!!  㭪   ᯮ짮 ⮫쪮    ࠬ *
 *    GA.                                                          *
 **************************************************************************/
//static unsigned    Old_Vect_ES, //६ 㪠뢠騥  
//		   Old_Vect_BX; // 1FH

// ,   맮 Set_Graph_Sim.
//                    0 - 
//                    1 - 
static unsigned short Can_Back;
char near CHAR_DAT[1024] = {
0x3C,0x6C,0xCC,0xCC,0xCC,0xFC,0xCC,0xCC, //
0xFC,0xC0,0xC0,0xF8,0xCC,0xCC,0xCC,0xF8, //
0xF0,0xD8,0xD8,0xF0,0xD8,0xCC,0xD8,0xF8, //
0xFC,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0,0xC0, //
0x1C,0x3C,0x6C,0x4C,0x4C,0x4C,0x4C,0xFC, //
0xFC,0xC0,0xC0,0xF0,0xC0,0xC0,0xC0,0xFC, //
0xB4,0xB4,0x78,0x30,0x78,0xFC,0xB4,0xB4, //
0x78,0x8C,0x1C,0x38,0x1C,0x0C,0x9C,0x78, //
0xCC,0xCC,0xCC,0xDC,0xDC,0xFC,0xEC,0xCC, //
0xD4,0xD4,0xC4,0xCC,0xDC,0xF4,0xE4,0xC4, //
0xC4,0xCC,0xD8,0xF0,0xF0,0xD8,0xCC,0xC4, //
0x3C,0x6C,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC, //
0xC6,0xEE,0xFE,0xD6,0xC6,0xC6,0xC6,0xC6, //
0xCC,0xCC,0xCC,0xFC,0xCC,0xCC,0xCC,0xCC, //
0x78,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0x78, //
0xFC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC,0xCC, //
0xF8,0xCC,0xC4,0xCC,0xF8,0xC0,0xC0,0xC0, //
0x78,0xC4,0xC0,0xC0,0xC0,0xC0,0xC4,0x78, //
0xFC,0x30,0x30,0x30,0x30,0x30,0x30,0x30, //
0xCC,0xCC,0xCC,0x6C,0x3C,0x0C,0x9C,0x78, //
0x30,0x78,0xB4,0xB4,0xB4,0x78,0x30,0x30, //
0x84,0xCC,0x78,0x30,0x30,0x78,0xCC,0x84, //
0x8C,0x8C,0x8C,0x8C,0x8C,0xCC,0x7E,0x06, //
0xCC,0xCC,0xCC,0x6C,0x3C,0x0C,0x0C,0x0C, //
0xC4,0xC4,0xD4,0xD4,0xD4,0xD4,0xD4,0xFC, //
0xC4,0xC4,0xD4,0xD4,0xD4,0xD4,0xD4,0xFE, //
0xE0,0xC0,0xC0,0xF8,0xCC,0xC4,0xCC,0xF8, //
0xCC,0xCC,0xC4,0xF8,0xCC,0xC4,0xCC,0xF8, //
0xC0,0xC0,0xC0,0xF8,0xCC,0xC4,0xCC,0xF8, //
0x78,0x9C,0x0C,0x3C,0x3C,0x0C,0x9C,0x78, //
0xB8,0xAC,0xA4,0xE4,0xE4,0xA4,0xAC,0xB8, //
0x7C,0xCC,0xCC,0x7C,0x3C,0x6C,0xCC,0x8C, //
0x00,0x00,0x74,0xDC,0x8C,0x8C,0xDC,0x74, //
0x00,0x00,0xFC,0xC0,0xF8,0xCC,0xCC,0xF8, //
0x00,0x00,0xF0,0xD8,0xF0,0xFC,0xCC,0xFC, //
0x00,0x00,0xFC,0xC0,0xC0,0xC0,0xC0,0xC0, //
0x00,0x00,0x3C,0x6C,0x4C,0x4C,0x4C,0xFC, //
0x00,0x00,0xFC,0xC0,0xE0,0xF0,0xC0,0xFC, //
0x00,0x00,0xB4,0x78,0x30,0x78,0xFC,0xB4, //
0x00,0x00,0xF8,0x0C,0x38,0x18,0x0C,0xF8, //
0x00,0x00,0xCC,0xCC,0xDC,0xFC,0xEC,0xCC, //
0x00,0x00,0xD4,0xC4,0xCC,0xD4,0xE4,0xC4, //
0x00,0x00,0xCC,0xD8,0xF0,0xF0,0xD8,0xCC, //
0x00,0x00,0x3C,0x6C,0x4C,0xCC,0xCC,0xCC, //
0x00,0x00,0x8C,0xDC,0xFC,0xAC,0x8C,0x8C, //
0x00,0x00,0xCC,0xCC,0xFC,0xCC,0xCC,0xCC, //
0x00,0x00,0x78,0xCC,0xCC,0xCC,0xCC,0x78, //
0x00,0x00,0xFC,0xCC,0xCC,0xCC,0xCC,0xCC, //
0x88,0x22,0x88,0x22,0x88,0x22,0x88,0x22, // 
0xcc,0x33,0xcc,0x33,0xcc,0x33,0xcc,0x33, // 
0xee,0x77,0xbb,0x77,0xee,0xdd,0xbb,0xee, // 
0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18, // 
0x18,0x18,0x18,0xf8,0xf8,0x18,0x18,0x18, // 
0x18,0xf8,0xf8,0x18,0x18,0xf8,0xf8,0x18, // 
0x66,0x66,0x66,0xe6,0xe6,0x66,0x66,0x66, // 
0x00,0x00,0x00,0xfe,0xfe,0x66,0x66,0x66, // 
0x00,0xf8,0xf8,0x18,0x18,0xf8,0xf8,0x18, // 
0x66,0xe6,0xe6,0x66,0x66,0xe6,0xe6,0x66, // 
0x66,0x66,0x66,0x66,0x66,0x66,0x66,0x66, // 
0x00,0xfe,0xfe,0x06,0x06,0xe6,0xe6,0x66, // 
0x66,0xe6,0xe6,0x06,0x06,0xfe,0xfe,0x00, // 
0x66,0x66,0x66,0x66,0x66,0xfe,0xfe,0x00, // 
0x18,0xf8,0xf8,0x18,0x18,0xf8,0xf8,0x00, // 
0x00,0x00,0x00,0xf8,0xf8,0x18,0x18,0x18, // 
0x18,0x18,0x18,0x1f,0x1f,0x00,0x00,0x00, // 
0x18,0x18,0x18,0xff,0xff,0x00,0x00,0x00, // 
0x00,0x00,0x00,0xff,0xff,0x18,0x18,0x18, // 
0x18,0x18,0x18,0x1f,0x1f,0x18,0x18,0x18, // 
0x00,0x00,0x00,0xff,0xff,0x00,0x00,0x00, // 
0x18,0x18,0x18,0xff,0xff,0x18,0x18,0x18, // 
0x18,0x1f,0x1f,0x18,0x18,0x1f,0x1f,0x18, // 
0x66,0x67,0x67,0x66,0x66,0x67,0x67,0x66, // 
0x66,0x67,0x67,0x60,0x60,0x6f,0x6f,0x00, //  200
0x00,0x7f,0x7f,0x60,0x60,0x67,0x67,0x66, // 
0x66,0x66,0x66,0x66,0x66,0xff,0xff,0x00, // 
0x00,0xff,0xff,0x66,0x66,0x66,0x66,0x66, // 
0x66,0x67,0x67,0x66,0x66,0x67,0x67,0x66, // 
0x00,0xff,0xff,0x00,0x00,0xff,0xff,0x00, // 
0x66,0xe7,0xe7,0x66,0x66,0xe7,0xe7,0x66, // 
0x18,0xff,0xff,0x00,0x00,0xff,0xff,0x00, // 
0x66,0x66,0x66,0xff,0xff,0x00,0x00,0x00, // 
0x00,0xff,0xff,0x00,0x00,0xff,0xff,0x18, // 
0x00,0x00,0x00,0xff,0xff,0x66,0x66,0x66, //  210
0x66,0x66,0x66,0x7f,0x7f,0x00,0x00,0x00, // 
0x18,0x1f,0x1f,0x18,0x18,0x1f,0x1f,0x00, // 
0x00,0x1f,0x1f,0x18,0x18,0x1f,0x1f,0x18, // 
0x00,0x00,0x00,0x7f,0x7f,0x66,0x66,0x66, // 
0x66,0x66,0x66,0xe7,0xe7,0x66,0x66,0x66, // 
0x18,0xff,0xff,0x18,0x18,0xff,0xff,0x18, // 
0x18,0x18,0x18,0xf8,0xf8,0x00,0x00,0x00, // 
0x00,0x00,0x00,0x1f,0x1f,0x18,0x18,0x18, // 
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // 
0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff, //  220
0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0,0xf0, // 
0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x0f, // 
0xff,0xff,0xff,0xff,0x00,0x00,0x00,0x00, // 
0x00,0x00,0xF8,0xCC,0xCC,0xF8,0xC0,0xC0, //
0x00,0x00,0x78,0xC4,0xC0,0xC0,0xC4,0x78, //
0x00,0x00,0xFC,0x30,0x30,0x30,0x30,0x30, //
0x00,0x00,0xCC,0xCC,0x6C,0x3C,0x8C,0x78, //
0x00,0x00,0x30,0xFC,0xB4,0xB4,0xFC,0x30, //
0x00,0x00,0xCC,0x78,0x30,0x30,0x78,0xCC, //
0x00,0x00,0xD8,0xD8,0xD8,0xD8,0xFC,0x04, //
0x00,0x00,0xCC,0xCC,0xCC,0x7C,0x0C,0x0C, //
0x00,0x00,0x84,0x84,0xB4,0xB4,0xB4,0xFC, //
0x00,0x00,0x88,0x88,0xA8,0xA8,0xA8,0xFC, //
0x00,0x00,0xE0,0x40,0x78,0x4C,0x4C,0x78, //
0x00,0x00,0x8C,0x8C,0xE4,0xB4,0xB4,0xE4, //
0x00,0x00,0xC0,0xC0,0xF8,0xCC,0xCC,0xF8, //
0x00,0x00,0x78,0x8C,0x1C,0x1C,0x8C,0x78, //
0x00,0x00,0xB8,0xAC,0xE4,0xE4,0xAC,0xB8, //
0x00,0x00,0x7C,0xCC,0xEC,0x3C,0x6C,0xCC, //
0x28,0x00,0xFC,0xC0,0xF0,0xF0,0xC0,0xFC, // 240
0x90,0xFC,0xC0,0xC0,0xF0,0xC0,0xC0,0xFC, // 241

0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff, // 242-247
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,

0x00,0x00,0x3C,0x7E,0x7E,0x3C,0x00,0x00, //  248
0x00,0x00,0x18,0x3C,0x3C,0x18,0x00,0x00, //  249
0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00, //  250
0x18,0x18,0x7e,0x7e,0x18,0x18,0x00,0x7e, //251 
0x00,0xc6,0xe6,0xd6,0xde,0xce,0xc6,0xc6, //252 
0x81,0x42,0x18,0x24,0x24,0x18,0x42,0x81, //253 
0x00,0x00,0x3C,0x3C,0x3C,0x3C,0x00,0x00, //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 //
};
void Set_Graph_Sim( void ) {
//      
//asm {
	  asm{
	       PUSH  DS    //࠭塞 ॣ 
	       PUSH  ES    //࠭塞 ⥫ ᥣ

	       MOV   AH,Get_Interrupt   //㭪 祭 
	       MOV   AL,Tabl_Sim_Graph
	       INT   21H
	       MOV   AX,ES
//	       MOV   Old_Vect_ES,ES      //࠭塞  ,
//	       MOV   Old_Vect_BX,BX      //㪠뢠騩    ASCII

	       MOV   DX,OFFSET CHAR_DAT  //⠭ 㪠⥫  
	       MOV   AX,SEG    CHAR_DAT  //ᨬ
	       MOV   DS,AX

	       MOV   AH,Set_Interrupt    //㭪 ⠭ 뢠
	       MOV   AL,Tabl_Sim_Graph   //  짮⥫᪨ ⮢
	       INT   21H

//	       JMP   NEAR PTR EXIT       //室  ணࠬ
	     }

EXIT:     asm{
	       POP  ES   //⠭ ࠭ 祭
	       POP  DS
	     }
	  Can_Back = 1;  //塞  ⮬,   㦥
   return;
}
/**************************************************************************
 *  ணࠬ  ⠭ ண  뢠 1FH.        *
 *   ணࠬ  뢠 ⮫쪮 ᫥ ணࠬ          *
 *  Set_Graph_Sim.                                                        *
 *  !!!  㭪   ᯮ짮 ⮫쪮    ࠬ *
 *    GA.                                                          *
 **************************************************************************/
void Back_Graph_Sim( void ) {
  if ( Can_Back )       //᫨  㦠,  ⠭
  {
     asm{
	   PUSH  DS                  //࠭塞 ॣ 

//	   MOV   DX,Old_Vect_BX      //⠭ 㪠⥫  
//	   MOV   AX,Old_Vect_ES      //ᨬ
	   MOV   DS,AX

	   MOV   AH,Set_Interrupt    //㭪 ⠭ 뢠
	   MOV   AL,Tabl_Sim_Graph
	   INT   21H

	   POP   DS                  //⠭ ॣ
	}
  } // endif
  return;
}

/**************************************************************************
 *  ணࠬ  ଠ⭮ ⥪  ࠭. ଠ 뢮 ᮢ  *
 *   ଠ⮬ 㭪樨 printf.  뢮 ᯮ ⠭⭠ 㭪-  *
 *   outtextxy.                                                        *
 *  ᠭ ६:                                                  *
 *  xcol -  뢮                                                 *
 *  ycol - ப 뢮                                                  *
 *  fmt  - ଠ  뢮                                              *
 **************************************************************************/
void Gprintf( int xloc, int yloc, char far *fmt, ... ) {
  va_list  argptr;                       //⥫  । 㬥
  char str[ Va_Str_Buf ];                //  ८ࠧ 㬥⮢

  va_start( argptr, fmt );               //樠 va_  㭪樨
  vsprintf( str, fmt, argptr );          //८ࠧ ப  
  CURSOR_OFF();
  outtextxy( xloc, yloc, str );          //뢮 祭 ப
  CURSOR_ON();
  va_end( argptr );                      //뢠  va_ 㭪
  return;
}

/**************************************************************************
 *  ணࠬ   ⪠ ࠭,  ᯮ짮 ࠭ *
 *  梥. ந室  ந쭮 .  ⢮ ப  - *
 *     (⨬).       ᯮ짮- *
 *   ᪨ 権 .                                   *
 *  !!!  㭪   ᯮ짮 ⮫쪮    ࠬ *
 *    GA.                                                          *
 *  ᠭ ६:                                                  *
 *  X1 -   砫                                 *
 *  Y1 - ப  砫                                  *
 *  X2 -                                     *
 *  Y2 - ப                                     *
 *  color - 梥                                                 *
 **************************************************************************/
void Chand( int X1, int Y1, int X2, int Y2, COLOR color, MODE oper ) {
 CURSOR_OFF();
    asm{  //ந 砫 ⠭
	  PUSH ES         //࠭ . ᥣ
	  MOV  AX,Start_Video_Buf  //뢠  砫 
	  MOV  ES,AX
	  MOV  DX,Video_Port     //뤠 㪠   ० 
	  MOV  AL,05H            // ࠢ 0
	  OUT  DX,AL
	  INC  DX
	  XOR  AL,AL             //
	  OUT  DX,AL
	  DEC  DX           //뢠   ᯮᮡ 
	  MOV  AL,03H       //ࠦ
	  OUT  DX,AL        //뢠  ॣ ᬥ饭
	  INC  DX
	  MOV  AL,oper      //뢠  
	  OUT  DX,AL        //塞 ॣ 饭
	  MOV  DX,Video_Color   //⠭ 梥  ࠭
	  MOV  AL,02H
	  OUT  DX,AL
	  INC  DX
	  MOV  AL,color         // 梥
	  OUT  DX,AL
	  MOV  AX,Y1      // ப 㬭  80  祭
	  MOV  CL,04H //!!!
	  SHL  AX,CL     //ᬥ饭  
	  MOV  BX,AX
	  MOV  CL,02H //!!!
	  SHL  AX,CL
	  ADD  BX,AX
	  // ஢ન ࠧa 
	  MOV  CX,X1
	  MOV  AX,CX   //࠭塞  न  쭩襣 ᯮ.
	  MOV  DX,X2
	  PUSH DX      //࠭塞  न  쭥襣 ᯮ.
	  SHR  CX,01H  //室 ᬥ饭 न  砫  
	  SHR  CX,01H
	  SHR  CX,01H
	  PUSH  CX
	  MOV  CL,03H
	  SHR  DX,CL  // ⮣    8 ( ᥫ  )
	  POP  CX     // !!!
	  ADD  BX,CX   //뢠 ᬥ饭  㪠⥫
	  CMP  CX,DX   //᫨  ࠢ,   ࠡ ᪮쪨 
	  JNZ  MANY_BL
// ************      ************
	  NOT  AL            //  宦. ᬥ饭 ᥫ 1  
	  AND  AL,00000111B  //뤥 㦭 ⮢
	  MOV  CL,AL
	  XOR  CH,CH
	  MOV  AL,01H
	  OR   CL,CL
	  JZ   IGN3
	}
REP1:asm{ STC                //⠭ 䫠 ७
	  RCL  AL,01H        //  ࠢ 1 ⮬
	  LOOP REP1
	}
IGN3:asm{ POP  DX            //⠭ 祭 ண 
	  NOT  DL            //  宦 ᬥ. ᥫ 2  
	  AND  DL,00000111B  //뤥 ⮢
	  MOV  CL,DL
	  XOR  CH,CH
	  XOR  AH,AH

	  OR   CL,CL
	  JZ   IGNO
	}
REP2:asm{ STC                //⠭ 䫠 ७
	  RCL  AH,01H        //  ࠢ 1 ⮬
	  LOOP REP2
	}
IGNO:asm{
	  XOR  AL,AH        //砥 ࠧ襭 ⮢ ᪮
	  MOV  DX,Video_Port          //蠥  
	  MOV  AH,AL
	  MOV  AL,08H                 //⮢ ᪮
	  OUT  DX,AL
	  MOV  AL,AH
	  INC  DX
	  OUT  DX,AL

	  MOV  DX,Y1        //뢠 ⢮ ப 
	  MOV  CX,Y2
	  SUB  CX,DX
	  INC  CX           //祭   1  祭 
			    //ப
	  MOV  AH,0FFH    //⠭  梥⮢
	  MOV  AL,oper    // 
	  CMP  AL,0FH     //᫨ AND,   ࠢ 0
	  JNZ  NEXT_LINE1
	  XOR  AH,AH      //  AND
	}
NEXT_LINE1:asm{  //।⢥ 
		 MOV  AL,ES:[BX] //⠥ ॣ 
		 MOV  ES:[BX],AH //塞 8 ᥫ
		 ADD  BX,Line_Next_Col //室  ᫥饩 ப
		 LOOP NEXT_LINE1       //  ப ࠡ⠭ ?
		 JMP  NEAR PTR EXIT       //室   
	      }
// *************      
MANY_BL:   asm{
		 NOT  AL            //  宦. ᬥ饭 ᥫ 1
		 AND  AL,00000111B  //뤥 ⮢
		 MOV  CL,AL
		 XOR  CH,CH
		 MOV  AL,01H
		 OR   CL,CL
		 JZ   IGN1
	      }
REP3:      asm{  STC                //⠭ 䫠 ७
		 RCL  AL,01H        // 
		 LOOP REP3
	      }
IGN1:      asm{  MOV  DX,Video_Port        //蠥  
		 MOV  AH,AL
		 MOV  AL,08H                //⮢ ᪮
		 OUT  DX,AL
		 MOV  AL,AH
		 INC  DX
		 OUT  DX,AL
		 MOV  DX,Y1        //뢠 ⢮ ப 
		 MOV  CX,Y2
		 SUB  CX,DX
		 INC  CX           //  ப
		 MOV  AH,0FFH    //⠭  梥⮢
		 MOV  AL,oper    // 
		 CMP  AL,0FH     //᫨ AND,   ࠢ 0
		 JNZ  NEXT_LINE2
		 XOR  AH,AH      //  AND
	       }
NEXT_LINE2:asm{  //।⢥ 
		 MOV  AL,ES:[BX] //⠥ ॣ 
		 MOV  ES:[BX],AH //塞 8 ᥫ
		 ADD  BX,Line_Next_Col
		 LOOP NEXT_LINE2       //  ப ࠡ⠭ ?
		 //  ࠡ⪨ ன न
		 MOV  AX,Y1      // ப 㬭  80  祭
		      PUSH CX //!!!
		 MOV  CL,04H//!!!
		 SHL  AX,CL     //ᬥ饭  
		 MOV  BX,AX
		 MOV  CL,02H //!!!
		 SHL  AX,CL

		 ADD  BX,AX
		 POP  DX         //⠭ 祭 ன न
		 MOV  AX,DX      //宦 ᬥ饭   

		 MOV  CL,03H
		 SHR  DX,CL
		      POP  CX //!!!
		 ADD  BX,DX
		 NOT  AL         //⠭ ࠧ襭    2
		 AND  AL,00000111B
		 MOV  CL,08H
		 SUB  CL,AL
		 XOR  AX,AX
		 XOR  CH,CH
		 OR   CL,CL
		 JZ   IGN2
	      }
REP4:      asm{  STC             //⠭ 䫠 ७
		 RCR  AL,01H
		 LOOP REP4
	      }
IGN2:      asm{  MOV  DX,Video_Port   //蠥  
		 MOV  AH,AL
		 MOV  AL,08H          //⮢ ᪮
		 OUT  DX,AL
		 MOV  AL,AH
		 INC  DX
		 OUT  DX,AL
		 MOV  DX,Y1        //뢠 ⢮ ப 
		 MOV  CX,Y2
		 SUB  CX,DX
		 INC  CX
		 MOV  AH,0FFH    //⠭  梥⮢
		 MOV  AL,oper    // 
		 CMP  AL,0FH     //᫨ AND,   ࠢ 0
		 JNZ  NEXT_LINE3
		 XOR  AH,AH      //  AND
	       }
NEXT_LINE3:asm{  //।⢥ 
		 MOV  AL,ES:[BX] //⠥ ॣ 
		 MOV  ES:[BX],AH //塞 8 ᥫ
		 ADD  BX,Line_Next_Col
		 LOOP NEXT_LINE3       //  ப ࠡ⠭ ?
		 MOV  CX,X1     //।塞 㦭  ७ . 
		 MOV  AX,X2
		 SHR  CX,01H    // ⮫殢  8
		 SHR  CX,01H
		 SHR  CX,01H
		 SHR  AX,01H
		 SHR  AX,01H
		 SHR  AX,01H
		 SUB  AX,CX     //᫨  ࠧ >1,  ࠡ⪠ 㦭
		 CMP  AX,01H
		 JZ   EXIT     //᫨  㦭,  室  ணࠬ
		 SHL  CX,01H  //㦭, 室 ࠬ  ।
		 SHL  CX,01H
		 SHL  CX,01H
		 ADD  CX,08H
		 MOV  X1,CX    // 㭪 Chen_Block
		 DEC  AX
		 MOV  X2,AX

		 MOV  DX,Y1        //뢠 ⢮ ப 
		 MOV  CX,Y2
		 SUB  CX,DX
		 INC  CX
		 MOV  Y2,CX
	      }
	   Chan_Block( X1, Y1, X2, Y2, color, oper ); //. . 

EXIT:      asm   POP  ES     //⠭ ⥫ ᥣ
 bar (0,0,0,0);
 CURSOR_ON();
 return;
}

/**************************************************************************
 *  ணࠬ  뢮 ࠧ梥⭮ ⥪  ࠭  ᪮   *
 *  ०.  '$'    梥.  '&'      *
 *   室   ப.                                        *
 *  ᠭ ६:                                                  *
 *  x -  뢮                                                    *
 *  y - ப 뢮                                                     *
 *  color1 - ᭮ 梥  뢮                                     *
 *  color2 - ୠ⨢ 梥  뢮                               *
 *  s - ப  뢮                                                 *
 **************************************************************************/

void Print( int x, int y, COLOR color1, COLOR color2, char *s ) {
 char  *d = s;     //㡫㥬 㪠⥫  ப
 COLOR c;          //६ 㪠⥫ 梥
 int t=x,          //⥫ 砫
     v=x;          //⥫ ⥪饣 뢮
 CURSOR_OFF();setcolor( color1 ); //⠭ 砫쭮 梥
 while( *d )  { //த ࠡ   ப
  switch ( *d )  {   //஢ઠ ⥪饣 ᨬ
   case '$':
    c=color1;           //  梥  뢮
    color1=color2;      // ப  ࠭
    color2=c;
    *d = '\0';       //砥 ப
    outtextxy(x,y,s);   //뢮 祭 ப
    setcolor(color1);   //塞 梥  
    *d++ = '$'; //⠭ 祭 ப  쭥襣 ᯮ짮
    x = v;              //塞 न 뢮
    s = d;              //頥 㪠⥫  ப
   break;
   case '&':
    *d = '\0';        // ७ ⥪  ࠭
    outtextxy(x,y,s); // 뢮  ப
    *d++ = '&';         //⠭  祭
    y += 10;            //室  ᫥ ப
    x = v = t;          //⠭  砫 뢮
    s = d;              //頥 㪠⥫  ப
   break;
   default:
    d++;                // 室  ᫥饬 ᨬ
    v += 8;             //室  ᫥饩 樨
  }             // switch
 }               // while
 outtextxy( x, y, s);  //뢮 ᫥  ப  ࠭
 CURSOR_ON();return;
}


/***************************************************************************
 *   ணࠬ ஢,    ப ᨬ - *
 *     . ᫨  ,  뤠  浪    *
 *    ப, ࠡ⠭  " 4". ᫨  ᨬ , *
 *   뤠 祭 100.                                              *
 *  ᠭ ६:                                                    *
 *  str - ⮪,  ந                                     *
 *  sim -                                                     *
 ***************************************************************************/
MODE Find_Key( char *str, char sim ) {
 MODE i = 0; //饭  ப
 //  ᮢ   ப
 while( ( *str ) && ( *str++ != sim) )
  i++;
 if ( *str )    //   ப
  i >>= 2;    //, ⮣ MOD 4
 else i = 100;    //, 頥 100
 return( i );
}

/***************************************************************************
 *  ணࠬa  뢠 ᨬ   . ᫥- *
 *    樨 .   ᬮ  䠩         *
 *  KEY.H. । 饭    뢠 ᨬ  -*
 *   , ᫨  .                                            *
 ***************************************************************************/
static KEY Buf[ MAX_BUF ];  //७  
/*static*/ KEY Start = 0,       //⥫  
	   End = 0;
char near  CHAR_TABL[128] = {
0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07, //00H
0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F, //08H
0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17, //10H
0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F, //18H
0x20,0x21,0x9D,0x2F,0xFD,0x3A,0x2E,0xED, //20H  !"# $%&'
0x3F,0x25,0x3B,0x2B,0xA1,0x2D,0xEE,0xF0, //28H ()*+ ,-./
0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37, //30H 0123 4567
0x38,0x39,0x86,0xA6,0x81,0x3D,0x9E,0xF1, //38H 89:; <=>?
0x22,0x94,0x88,0x91,0x82,0x93,0x80,0x8F, //40H @ABC DEFG
0x90,0x98,0x8E,0x8B,0x84,0x9C,0x92,0x99, //48H HIJK LMNO
0x87,0x89,0x8A,0x9B,0x85,0x83,0x8C,0x96, //50H PQRS TUVW
0x97,0x8D,0x9F,0xE5,0x5C,0xEA,0x2C,0x5F, //58H XYZ[ \]^_
0x29,0xE4,0xA8,0xE1,0xA2,0xE3,0xA0,0xAF, //60H `abc defg
0xE0,0xE8,0xAE,0xAB,0xA4,0xEC,0xE2,0xE9, //68H hijk lmno
0xA7,0xA9,0xAA,0xEB,0xA5,0xA3,0xAC,0xE6, //70H pqrs tuvw
0xE7,0xAD,0xEF,0x95,0x7C,0x9A,0x28,0x7F  //78H xyz{ |}~
};

KEY  Get_Key( void ) {
  KEY  sim;              //,  㤥 ᮤঠ 祭 

//       
//asm {

  if (Start != End)      //  ᨬ  ७ 
  {
    sim = Buf[ End++ ];  //,  ᨬ
    End %= MAX_BUF;    //஫ 室  । 
  }
  else
  {
       asm{
	    PUSH ES         //C࠭塞 ⥫ ᥣ
	    MOV  AH,Get_Key_BIOS     //뢠 ᨬ   
	    INT  16H
	    CMP  AL,00H     //᫨ ७ ,  室
	    JNZ   NEXT1
	    JMP  NEAR PTR EXIT
	  }
NEXT1: asm{
	    XOR  AH,AH      //㫥 孥 
//            mov  Hu,al //!!!
	    CMP  AL,080H    //᫨ ᨬ  ⠭ ASCII,  室
	    JB   NEXT2
	    JMP  NEAR PTR EXIT
	  }
NEXT2: asm{
	    MOV  CX,AX      //࠭塞 祭 
	    MOV  AH,Chack_Key_BIOS   //  ० Scroll
	    INT  16H
	    TEST AL,00010000B
	    MOV  AX,CX            //⠭ 祭 
	    JNZ  NEXT3            //᫨ ,  室
	    JMP  NEAR PTR EXIT
	  }
NEXT3: asm{
	    MOV  BX,OFFSET CHAR_TABL    //८ࠧ. 祭 ᨬ  ᪨
	    MOV  CX,SEG CHAR_TABL       // 襩  ⠡
	    MOV  ES,CX
	    ADD  BX,AX
	    MOV  AL,ES:[BX]           //뢠 ஡ࠧ ᨬ
//	    JMP  NEAR PTR EXIT
	  }
EXIT:       asm{
		 MOV  sim,AX   //⠭ 
		 POP  ES       //⠭ ⥫ ᥣ
	       }
   } // else

   return (sim);              //頥 祭 ᨬ
}

/***************************************************************************
 *  ணࠬa  뢠 ᨬ  ७  ணࠬ.   *
 *   ᨬ  ⠭  ᫥饬 饭  㭪樨 Get_Key.   *
 *  ७  ࣠ 横᪨,  讬 ⢥ -   *
 *  ᥩ     .       *
 *  ᯫ ६ MAX_BUF.                                           *
 *  ணࠬ  ६ ᫮ ࠬ஢.                        *
 *  kol - ⢮ 뢠 ᨬ                                 *
 ***************************************************************************/
void Set_Key( KEY kol, ... ) {
  KEY  *ptr = &kol;           //뢠   ᨬ  ப ࠬ.
  for(; kol != 0; kol-- )   {
    Buf[ Start++ ] = *++ptr;  //᫥⥫쭮 뢠  ᨬ
    Start %= (MAX_BUF);     // ७ 
  }
  return;
}

/***************************************************************************
 *  ணࠬa  뢠 ᨬ  ७  ணࠬ.   *
 *   ᨬ  ⠭  ᫥饬 饭  㭪樨 Get_Key.   *
 *  ७  ࣠ 横᪨,  讬 ⢥ -   *
 *  ᥩ     .       *
 *  ᯫ ६ MAX_BUF.                                           *
 *  ,   ᫥  饭  㪭樨 㤥    *
 *  , .. 㤥 ᯮ                                      *
 *  ணࠬ  ६ ᫮ ࠬ஢.                        *
 *  kol - ⢮ 뢠 ᨬ                                 *
 ***************************************************************************/

void Set_Insert_Key( KEY kol, ... ) {
  KEY  *ptr = &kol;           //뢠   ᨬ  ப ࠬ.
  for(; kol != 0; kol-- )   {
    if( !(End)-- )        //᫥⥫쭮 뢠  ᨬ
      End = MAX_BUF-1;
    Buf[ End ] = *++ptr;   // ७ 
  }
  return;
}

 /***************************************************************************
 *                                                                         *
 *  ணࠬa ⪨  .                                *
 *                                                                         *
 ***************************************************************************/
void Clear_Buf( void ) {
  End = Start;
  asm{
      PUSH  ES            //࠭塞 ⥫ ᥣ
      CLI                 //頥 뢠
      SUB   AX,AX
      MOV   ES,AX
      MOV   AX,ES:[41AH] //⠭ 㪠⥫  
      MOV   ES:[41CH],AX //  ⮦ 祭
      STI                 //蠥 뢠
      POP   ES            //⠭ ⥫ ᥣ
     }
 return;
}

KEY Hit_Key (void) {
if (Start != End) return (1);
asm push es;
asm  mov ax,0;
asm  mov es,ax;
asm  mov ax,es:[41ah];
asm  mov cx,es:[41ch];
asm pop es;
 if (_AX==_CX) return (0);
 return (1);
}


/****************************************************************************
 *      ணࠬ ந     ⥫쭮  *
 * ணࠬ  ࠡ   設 IBM.                         *
 * ணࠬ  ᯮ짮  뤠 ।।⥫ ᨣ  *
 *   ந 모.                                             *
 *                                                                          *
 * ᠭ ६:                                                     *
 * chastota -  砭                                              *
 * pause - ⥫쭮 ( 1 = 1 ᥪ㭤 )                               *
 ****************************************************************************/
void Sound( int chastota, int pause ) {
extern char SOUND;

 if( SOUND )  { // ᫨ ᨣ ࠧ襭,  뤠 
   asm{
	  PUSH  AX   //࠭塞 ᯮ㥬 ॣ
	  PUSH  BX
	  PUSH  CX
	  PUSH  DX
	  PUSH  DI

	  CLI                  //頥 뢠
	  MOV   DI,chastota    //७ᨬ 祭  ॣ
	  MOV   BX,pause

	  MOV   AL,0B6H      //  ॣ ० ⠩
	  OUT   43H,AL
	  MOV   DX,14H       //⥫쭮 ६ =
	  MOV   AX,4F38H     //1331000 / 
	  DIV   DI

	  OUT   42H,AL       // 訩  稪 ⠩ 2
	  MOV   AL,AH
	  OUT   42H,AL       // 訩  稪 ⠩ 2

	  IN    AL,61H       // ⥪ ⠭  
	  MOV   AH,AL        // ࠭   ॣ AH
	  OR    AL,03H       // 
	  OUT   61H,AL
	}
WAIT:asm  MOV   CX,2A00H     //릤 10 
SPKR:asm{
	  LOOP  SPKR
	  DEC   BX           //稪 ⥫쭮 ௠ ?
	  JNZ   WAIT         //. த 砭

	  MOV   AL,AH        //. ⠭ 室 ⠭ 
	  OUT   61H,AL

	  POP   DI           //⠭ ॣ
	  POP   DX
	  POP   CX
	  POP   BX
	  POP   AX
	  STI                // 뢠
	}
 } // if
 return;
}

/* void Locate( char kol, char strok, char page ) {
  asm  MOV    DL,kol    ;
  asm  MOV    DH,strok  ;
  asm  MOV    BH,page   ;
  asm  MOV    AH,02h    ;
  asm INT    10h        ;
}  */


// Void function
void Nop( void ){ return; }
